/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.sablecc.node;

import de.hhu.stups.sablecc.patch.IToken;
import de.hhu.stups.sablecc.patch.SourcePosition;

public abstract class Token extends Node implements IToken
{
    private String text;
    private int line;
    private int pos;

    protected Token(String text, int line, int pos)
    {
        this.text = text;
        this.line = line;
        this.pos = pos;
    }

    protected Token(String text)
    {
        this(text, 0, 0);
    }

    protected Token()
    {
        this(null);
    }

    @Override
    public abstract Token clone();

    @Override
    public String getText()
    {
        return this.text;
    }

    @Override
    public void setText(String text)
    {
        this.text = text;
        // Invalidate any already calculated SourcePositions
        setStartPos(null);
        setEndPos(null);
    }

    @Override
    public int getLine()
    {
        return this.line;
    }

    @Override
    public void setLine(int line)
    {
        this.line = line;
        // Invalidate any already calculated SourcePositions
        setStartPos(null);
        setEndPos(null);
    }

    @Override
    public int getPos()
    {
        return this.pos;
    }

    @Override
    public void setPos(int pos)
    {
        this.pos = pos;
        // Invalidate any already calculated SourcePositions
        setStartPos(null);
        setEndPos(null);
    }

    // startPos and endPos are calculated lazily to avoid creating two SourcePosition objects for every token.

    @Override
    public SourcePosition getStartPos()
    {
        SourcePosition startPos = super.getStartPos();
        if(startPos == null)
        {
            startPos = new SourcePosition(this.line, this.pos);
            setStartPos(startPos);
        }
        return startPos;
    }

    @Override
    public SourcePosition getEndPos()
    {
        SourcePosition endPos = super.getEndPos();
        if(endPos == null)
        {
            endPos = new SourcePosition(this.line, this.pos + (this.text == null ? 0 : this.text.length()));
            setEndPos(endPos);
        }
        return endPos;
    }

    @Override
    public String toString()
    {
        return this.text + " ";
    }

    @Override
    void removeChild(Node child)
    {
        throw new RuntimeException("Not a child.");
    }

    @Override
    void replaceChild(Node oldChild, Node newChild)
    {
        throw new RuntimeException("Not a child.");
    }
}
